using System;
using System.Text.Json.Serialization;
namespace org.accordproject.creativework {
   using org.accordproject.time;
   using org.accordproject.person;
   using org.accordproject.organization;
   using concerto;
   enum BookGenre {
      Fantasy,
      Romance,
   }

   enum Medium {
      Audio,
      Print,
      Video,
   }

   class CreativeWork : Concept {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.creativework.CreativeWork";
      public Person[] creators { get; set; }
      public DateTime dateCreated { get; set; }
      public Medium medium { get; set; }
      public string title { get; set; }
   }
   class Album : CreativeWork {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.creativework.Album";
      public Song[] songs { get; set; }
   }
   class Book : CreativeWork {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.creativework.Book";
      public Organization publisher { get; set; }
      public BookGenre genre { get; set; }
   }
   enum MusicGenre {
      Rock,
      Rap,
      Country,
      Pop,
      Jazz,
      Grime,
      ThrashMetal,
   }

   class Song : CreativeWork {
      [JsonPropertyName("$class")]
      public new string _class { get;} = "org.accordproject.creativework.Song";
      public Duration duration { get; set; }
      public MusicGenre genre { get; set; }
      public Person[] performers { get; set; }
   }
}
